<?php
/*
Plugin Name: Scissors
Plugin URI: http://stephanreiter.info/2008/10/wordpress-plugin-scissors/
Description: This plugin adds cropping and resizing functionality to Wordpress' image upload and management dialogs.
Version: 0.93
Author: Stephan Reiter
Author URI: http://stephanreiter.info/

Copyright (C) 2008  Stephan Reiter <stephan.reiter@gmail.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

function scissors_admin_head()
{
	if(strstr($_SERVER['REQUEST_URI'], 'media'))
	{
		$scissors_dirname = plugin_basename(dirname(__FILE__));
		load_plugin_textdomain('scissors', PLUGINDIR . '/' . $scissors_dirname . '/i18n');

		// TODO: use wp_enqueue_script?
		$url = plugins_url($scissors_dirname);
		echo "<script src='$url/js/jquery.pack.js'></script>\n";
		echo "<script src='$url/js/jquery.Jcrop.pack.js'></script>\n";
		echo "<script src='$url/js/scissors.js'></script>\n";
		echo "<link rel='stylesheet' href='$url/css/jquery.Jcrop.css' type='text/css' media='all' />\n";
		echo "<link rel='stylesheet' href='$url/css/scissors.css' type='text/css' media='all' />\n";
	}
}

function gcd($a, $b)
{
	if ($a == 0 || $b == 0)
		return 0;
	else if ($a == $b)
		return $a;
	else
	{
		do
		{
			$r = $a % $b;
			$a = $b; $b = $r;
		} while($r != 0);
		return $a;
	}
}

function scissors_media_meta($string, $post)
{
	if($post->post_mime_type == 'image/jpeg' || $post->post_mime_type == 'image/png')
	{
		$text_crop = __('Crop', 'scissors');
		$text_resize = __('Resize', 'scissors');
		$text_abort = __('Abort', 'scissors');
		$text_crop2 = __('Crop %s.', 'scissors');
		$text_crop3 = __('Lock aspect ratio to %s.', 'scissors');
		$text_width = __('width', 'scissors');
		$text_height = __('height', 'scissors');
		$text_longside = __('long side', 'scissors');
		$text_shortside = __('short side', 'scissors');
		$text_resize2 = __('Resize %1$s to %2$s pixels.', 'scissors');
		$text_arei = __('Use automatic relevance-enhanced image reduction.', 'scissors');

		$image_url = wp_get_attachment_url($post->ID);
		$postId = $post->ID;
		$thisUrl = admin_url('admin-ajax.php');
		$nonce = wp_create_nonce("scissors-$postId");

		$filename = get_attached_file($postId);
		if($filename && file_exists($filename))
			list($width, $height) = getimagesize($filename);
		$img_size = isset($width) ? ($width . '&nbsp;&times;&nbsp;' . $height) : '';
	
		$string .= "<span id='scissorsSize-$postId'>$img_size</span></td></tr>\n\t\t<tr>";
		$string .= "<th valign='top' scope='row' class='label'>Scissors</th><td class='field'>";
		$string .= "<div id='scissorsShowBtn-$postId'>";
		$string .= "<button class='button' onclick=\"return scissorsShowCrop($postId, '$image_url')\">$text_crop</button>&nbsp;";
		$string .= "<button class='button' onclick=\"return scissorsShowResize($postId)\">$text_resize</button>";
		$string .= "</div>";

		$text_targets = array('chain' => __('full chain', 'scissors'), 'full' => __('large', 'scissors'),
			'medium' => __('medium', 'scissors'), 'thumbnail' => __('thumbnail', 'scissors'));
		$cropTargets = "<select id='scissorsCropTarget-$postId' onchange=\"scissorsCropTargetChange($postId)\">";
		$cropTargets .= "<option value='chain' selected='true'>" . $text_targets['chain'] . "</option>";
		$cropTargets .= "<option value='full'>" . $text_targets['full'] . "</option>";
   		$sizes = apply_filters('intermediate_image_sizes', array('medium', 'thumbnail'));
		foreach($sizes as $size)
		{
			if($intermediate = image_get_intermediate_size($postId, $size))
			{
				$text_target = isset($text_targets[$size]) ? $text_targets[$size] : $size;
				$cropTargets .= "<option value='$size'>" . $text_target . "</option>";
			}
		}
		$cropTargets .= "</select>";

		$aspectX = isset($width) ? $width : 4;
		$aspectY = isset($height) ? $height : 3;
		while(($g = gcd($aspectX, $aspectY)) > 1)
		{
			$aspectX = intval($aspectX / $g);
			$aspectY = intval($aspectY / $g);
		}
		$cropAspect  = "<input style='width:2em;text-align:center;' type='text' onchange=\"scissorsAspectChange($postId)\" id='scissorsLockX-$postId' value='$aspectX' />:";
		$cropAspect .= "<input style='width:2em;text-align:center;' type='text' onchange=\"scissorsAspectChange($postId)\" id='scissorsLockY-$postId' value='$aspectY' />";

		$string .= "<div class='scissorsPane' id='scissorsCropPane-$postId'>";
		$string .= sprintf($text_crop2, $cropTargets);
		$string .= "&nbsp;<button class='button' onclick=\"return scissorsCrop($postId, '$nonce', '$thisUrl')\">$text_crop</button>";
		$string .= "&nbsp;<button class='button' onclick=\"return scissorsAbortCrop($postId)\">$text_abort</button>";
		$string .= "<div class='scissorsImgHost' id='scissorsImgHost-$postId'><img id='scissorsImg-$postId' /></div>";
		$string .= "<input type='hidden' id='scissorsX-$postId' /><input type='hidden' id='scissorsY-$postId' />";
		$string .= "<input type='hidden' id='scissorsW-$postId' /><input type='hidden' id='scissorsH-$postId' />";
		$string .= "<span id='scissorsSel-$postId'></span>";
		$string .= "<span id='scissorsAspect-$postId'><br/><input type='checkbox' onchange=\"scissorsAspectChange($postId)\" id='scissorsLockBox-$postId' checked='true' />&nbsp;";
		$string .= sprintf($text_crop3, $cropAspect);
		$string .= "</span><span id='scissorsArei-$postId'><br/><input type='checkbox' id='scissorsAreiEnable-$postId' checked='true' />&nbsp;$text_arei&nbsp;<a href=\"http://www.useit.com/alertbox/9611.html\" target=\"_blank\">[?]</a></span>";
		$string .= "</div>";

		$resizeMode = "<select id='scissorsMode-$postId'><option value='width' selected='true'>$text_width</option><option value='height'>$text_height</option><option value='long'>$text_longside</option><option value='short'>$text_shortside</option></select>";
		$resizeValue = "<input style='width:3em;text-align:center;' type='text' id='scissorsSide-$postId' value='640' />";
		$string .= "<div class='scissorsPane' id='scissorsResizePane-$postId'>";
		$string .= sprintf($text_resize2, $resizeMode, $resizeValue);
		$string .= "&nbsp;<button class='button' onclick=\"return scissorsResize($postId, '$nonce', '$thisUrl')\">$text_resize</button>";
		$string .= "&nbsp;<button class='button' onclick=\"return scissorsAbortResize($postId)\">$text_abort</button>";
		$string .= "</div>";

		$string .= "<div class='scissorsPane scissorsWaitFld' id='scissorsWaitFld-$postId'></div>";
	}
	return $string;
}

function scissors_crop($post, $srcfile, $src)
{
	$x = intval($_POST['x']); $y = intval($_POST['y']);
	$w = intval($_POST['w']); $h = intval($_POST['h']);
	if($x >= 0 && $y >= 0 && $w > 0 && $h > 0)
	{
		$fullfile = get_attached_file($post->ID);
		if($_POST['target'] == 'chain' || $_POST['target'] == 'full')
			$dstfile = $fullfile;
		else if($intermediate = image_get_intermediate_size($post->ID, $_POST['target']))
			$dstfile = tempnam(dirname($fullfile), 'scissors');
		else
			return __('Invalid target.', 'scissors');

		$dst = imagecreatetruecolor($w, $h);
		if(is_resource($dst))
		{
			if(imagecopy($dst, $src, 0, 0, $x, $y, $w, $h))
			{
				switch($post->post_mime_type)
				{
				case 'image/jpeg': $result = imagejpeg($dst, $dstfile, 90); break;
				case 'image/png': $result = imagepng($dst, $dstfile); break;
				}
	
				if($result)
				{
					$metadata = wp_get_attachment_metadata($post->ID);
					if($_POST['target'] == 'chain' || $_POST['target'] == 'full')
					{
						// update meta data for the full-size image
						$metadata['width'] = $w; $metadata['height'] = $h;
						list($uwidth, $uheight) = wp_shrink_dimensions($metadata['width'], $metadata['height']);
						$metadata['hwstring_small'] = "height='$uheight' width='$uwidth'";

						$msg = "done;full,{$w},{$h}"; // signal change of the full-size image

						// update existing intermediate images if requested
						if($_POST['target'] == 'chain')
						{
							foreach($metadata['sizes'] as $size => $data)
							{
								$srcfile = $fullfile;
								$w2 = get_option("{$size}_size_w");
								$h2 = get_option("{$size}_size_h");
								if($_POST['arei'] == '1')
								{
									$fx = $w2 / $w; $fy = $h2 / $h;
									$factor = sqrt($fx > $fy ? $fx : $fy);
									$cw = ceil($w * $factor); $ch = ceil($h * $factor);
									if($cw != $w || $ch != $h)
									{
										$cx = floor(($w - $cw) / 2); $cy = floor(($h - $ch) / 2);
										$interfile = tempnam(dirname($fullfile), 'scissors');

										// crop $fullfile to ($cx,$cy) [$cw,$ch] and store to $interfile
										$tmp = imagecreatetruecolor($cw, $ch);
										if(is_resource($tmp))
										{
											if(imagecopy($tmp, $dst, 0, 0, $cx, $cy, $cw, $ch))
											{
												switch($post->post_mime_type)
												{
												case 'image/jpeg': $result = imagejpeg($tmp, $interfile, 90); break;
												case 'image/png': $result = imagepng($tmp, $interfile); break;
												}
												if($result) $srcfile = $interfile;
											}
											imagedestroy($tmp);
										}

										if($interfile != $interfile)
											unlink($interfile);
									}
								}
	
								$resized = image_make_intermediate_size($srcfile, $w2, $h2, get_option("{$size}_crop"));
								if($resized)
								{
									if($resized['file'] != $data['file'])
									{
										// overwrite the old file with the newly created image
										$resizedfile = path_join(dirname($srcfile), $resized['file']);
										$oldfile = path_join(dirname($fullfile), $data['file']);
										copy($resizedfile, $oldfile);
										unlink($resizedfile);
										$resized['file'] = $data['file'];
									}
									$metadata['sizes'][$size] = $resized;
									$msg .= "+$size," . $resized['width'] . ',' . $resized['height']; // signal change
								}

								if($srcfile != $fullfile)
									unlink($srcfile); // clean up arei temporary
							}
						}

						wp_update_attachment_metadata($post->ID, $metadata);
					}
					else
					{
						$size = $_POST['target'];
						$resized = image_make_intermediate_size($dstfile, get_option("{$size}_size_w"), get_option("{$size}_size_h"), get_option("{$size}_crop"));
						if($resized)
						{
							// overwrite the specified destination
							$resizedfile = path_join(dirname($dstfile), $resized['file']);
							$oldfile = path_join(dirname($fullfile), $intermediate['file']);
							if(copy($resizedfile, $oldfile))
							{
								$resized['file'] = $intermediate['file'];
								$metadata['sizes'][$size] = $resized;
								$msg = "done;$size," . $resized['width'] . ',' . $resized['height']; // signal change
							}
							else
								$msg = __('Failed to save new image.', 'scissors');

							unlink($resizedfile);
						}
						else
							$msg = __('Failed to save new image.', 'scissors');

						wp_update_attachment_metadata($post->ID, $metadata);
					}
				}
				else
					$msg = __('Failed to save new image.', 'scissors');
			}
			else
				$msg = __('Failed to crop image.', 'scissors');
	
			imagedestroy($dst);
		}
		else
			$msg = __('Failed to allocate memory.', 'scissors');

		// cleanup temporary file
		if($intermediate)
			unlink($dstfile);
		return $msg;
	}
	else
		return __('Invalid selection.', 'scissors');
}

function scissors_resize($post, $filename, $src)
{
	$side = intval($_POST['side']);
	if($side > 0)
	{
		$srcW = imagesx($src); $srcH = imagesy($src);
		switch($_POST['mode'])
		{
		case 'width': $w = $side; $h = ceil($srcH * $side / $srcW); break;
		case 'height': $h = $side; $w = ceil($srcW * $side / $srcH); break;
		case 'long':
			$w = ($srcW >= $srcH) ? $side : ceil($srcW * $side / $srcH);
			$h = ($srcH > $srcW) ? $side : ceil($srcH * $side / $srcW);
			break;
		case 'short':
			$w = ($srcW < $srcH) ? $side : ceil($srcW * $side / $srcH);
			$h = ($srcH <= $srcW) ? $side : ceil($srcH * $side / $srcW);
			break;
		default:
			return __('Invalid mode.', 'scissors');
		}
	
		if($w > 0 && $h > 0)
		{
			if($w != $srcW || $h != $srcH)
			{
				$dst = imagecreatetruecolor($w, $h);
				if(is_resource($dst))
				{
					if(imagecopyresampled($dst, $src, 0, 0, 0, 0, $w, $h, $srcW, $srcH))
					{
						switch($post->post_mime_type)
						{
						case 'image/jpeg': $result = imagejpeg($dst, $filename, 90); break;
						case 'image/png': $result = imagepng($dst, $filename); break;
						}

						if($result)
						{
							// update meta data, no need to rebuild intermediate images because the aspect ratio always stays the same
							$metadata = wp_get_attachment_metadata($post->ID);
							$metadata['width'] = $w; $metadata['height'] = $h;
							wp_update_attachment_metadata($post->ID, $metadata);
							$msg = "done;full,{$w},{$h}"; // signal change of the full-size image
						}
						else
							$msg = __('Failed to save new image.', 'scissors');
					}
					else
						$msg = __('Failed to resize image.', 'scissors');

					imagedestroy($dst);
					return $msg;
				}
				else
					return __('Failed to allocate memory.', 'scissors');
			}
			else
				return 'none;*'; // signal no change
		}
		else
			return __('Invalid destination dimensions.', 'scissors');
	}
	else
		return __('Invalid side length.', 'scissors');
}

function scissors_action()
{
	$postId = intval($_POST['post_id']); // perform security checks
	if (wp_verify_nonce($_POST['_wpnonce'], "scissors-$postId") && current_user_can('upload_files'))
	{
		// retrieve post data and load the full-size image
		$post = get_post($postId);
		$filename = get_attached_file($postId);
		if($post && $filename && file_exists($filename))
		{
			@ini_set('memory_limit', '256M');

			// load the source image
			switch($post->post_mime_type)
			{
			case 'image/jpeg': $src = imagecreatefromjpeg($filename); break;
			case 'image/png': $src = imagecreatefrompng($filename); break;
			}
			
			if(is_resource($src))
			{
				if($_POST['action'] == 'scissorsCrop')
					$msg = scissors_crop($post, $filename, $src);
				else if($_POST['action'] == 'scissorsResize')
					$msg = scissors_resize($post, $filename, $src);
				else
					$msg = __('Invalid query.', 'scissors');

				imagedestroy($src);
			}
			else
				$msg = __('Failed to load image.', 'scissors');
		}
		else
			$msg = __('Invalid post-id.', 'scissors');
	}
	else
		$msg = __('Unauthorized query.', 'scissors');
	die($msg);
}

add_filter('media_meta', 'scissors_media_meta', 99, 2);
add_action('admin_head', 'scissors_admin_head');
add_action('wp_ajax_scissorsCrop', 'scissors_action');
add_action('wp_ajax_scissorsResize', 'scissors_action');

?>